=begin
#validateapi

#The validation APIs help you validate data. Check if an E-mail address is real. Check if a domain is real. Check up on an IP address, and even where it is located. All this and much more is available in the validation API.

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.14

=end

require 'date'

module CloudmersiveValidateApiClient
  # Identifier validation request, including the input identifier as well as various identifier rules
  class ValidateIdentifierRequest
    # Text string identifier input
    attr_accessor :input

    # True if whitespace is allowed in the identifier, false otherwise
    attr_accessor :allow_whitespace

    # True if hyphens are allowd in the identifier, false otherwise
    attr_accessor :allow_hyphens

    # True if underscores are allowed in the identifier, false otherwise
    attr_accessor :allow_underscore

    # True if numbers are allowed in the identifier, false otherwise
    attr_accessor :allow_numbers

    # True if periods are allowed in the identifier, false otherwise
    attr_accessor :allow_periods

    # Optional; maximum length, if any, of the identifier
    attr_accessor :max_length

    # Optional; minimum length, if any, of the identifier
    attr_accessor :min_length

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'input' => :'Input',
        :'allow_whitespace' => :'AllowWhitespace',
        :'allow_hyphens' => :'AllowHyphens',
        :'allow_underscore' => :'AllowUnderscore',
        :'allow_numbers' => :'AllowNumbers',
        :'allow_periods' => :'AllowPeriods',
        :'max_length' => :'MaxLength',
        :'min_length' => :'MinLength'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'input' => :'String',
        :'allow_whitespace' => :'BOOLEAN',
        :'allow_hyphens' => :'BOOLEAN',
        :'allow_underscore' => :'BOOLEAN',
        :'allow_numbers' => :'BOOLEAN',
        :'allow_periods' => :'BOOLEAN',
        :'max_length' => :'Integer',
        :'min_length' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'Input')
        self.input = attributes[:'Input']
      end

      if attributes.has_key?(:'AllowWhitespace')
        self.allow_whitespace = attributes[:'AllowWhitespace']
      end

      if attributes.has_key?(:'AllowHyphens')
        self.allow_hyphens = attributes[:'AllowHyphens']
      end

      if attributes.has_key?(:'AllowUnderscore')
        self.allow_underscore = attributes[:'AllowUnderscore']
      end

      if attributes.has_key?(:'AllowNumbers')
        self.allow_numbers = attributes[:'AllowNumbers']
      end

      if attributes.has_key?(:'AllowPeriods')
        self.allow_periods = attributes[:'AllowPeriods']
      end

      if attributes.has_key?(:'MaxLength')
        self.max_length = attributes[:'MaxLength']
      end

      if attributes.has_key?(:'MinLength')
        self.min_length = attributes[:'MinLength']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          input == o.input &&
          allow_whitespace == o.allow_whitespace &&
          allow_hyphens == o.allow_hyphens &&
          allow_underscore == o.allow_underscore &&
          allow_numbers == o.allow_numbers &&
          allow_periods == o.allow_periods &&
          max_length == o.max_length &&
          min_length == o.min_length
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [input, allow_whitespace, allow_hyphens, allow_underscore, allow_numbers, allow_periods, max_length, min_length].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = CloudmersiveValidateApiClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
